var cmlg__trans_setup = function(){
	document.body.style.cursor = '';
	document.body.style.opacity = 1;
	
	let currentLang 	= '__';
	let currentLangTrans= '__';
	let urlTransQueue 	= []; //0 lang, 1 url, 2 english data.

	var eIframe = [];
	var obj_mlgpbe = [];
	var postId = 0;
	var timeStart = Date.now();
	var timeStartSave = Date.now();
	
	var ctrFramesLoaded = 0;
	var ctrFrames = 0;
	
	let tmp;
	let isMnt = 0; 
	let frozenText = 'zzz';
	let isAllProccessed = 0;
	
	async function gatherUrls( type ){
		try{
			const u = cmlg_globe_tsst.adminUrlSlash + '?cmlg_tnsc=100&tpt='+type+'&__' + Date.now();
			console.log('gatherUrls:',u);

			await fetch(u);
		}catch(e){
			//
		}
	}

/* 	function get_gene_page_lang( lang, tmExtra){
		//https://wp64-demo.everlive.net/for-etc-trans-gene/?cmlg_oc=100&cmlang=fr
		const url = cmlg_globe_tsst.siteUrlSlash + 'for-etc-trans-gene/?cmlg_oc=100&cmlang='+lang;
		var iframe = document.createElement('iframe');
		
		console.log( 'get_gene_page_lang: Going to load gene:', url );
		
		iframe.style.top = '0';
		iframe.style.left = '0';
		iframe.style.width = '100%';
		iframe.style.height = '600px';
		iframe.style.opacity = 0;
		iframe.style.backgroundColor = 'white';
		iframe.style.position = 'absolute';
		iframe.style.zIndex = 999999999;

		iframe.src = url;
		
		iframe.onload = function() {
			setTimeout( function(){
				//document.body.removeChild(iframe);
			}, 3000 + tmExtra);
		};
		
		document.body.appendChild(iframe);
	}
 */	

	function get_gene_page( lang = '', tmExtra = 0 ){
		const url = cmlg_globe_tsst.siteUrlSlash + lang + 'for-etc-trans-gene/';
		var iframe = document.createElement('iframe');
		
		console.log( 'get_gene_page: Going to load gene:', url );
		
		iframe.src = url;
		iframe.style.display = 'none'; // Hide the iframe initially
		
		iframe.onload = function() {
			setTimeout( function(){
				document.body.removeChild(iframe);
			}, 3000 + tmExtra);
		};
		
		document.body.appendChild(iframe);
	}

	async function startFindUrls(){
		//fire 4 ajax with await to start finding and putting urls in the table cmlg_url_list
		
		await gatherUrls('post');
		await gatherUrls('page');
		//await gatherUrls('product');
		
		//alert('gather done');
	}
	
	async function processOneUrl(){
		//fire ajax to pick a url from table via php (file_get_contents) and
		//make its translation template (.tpl.html) file.
		const u = cmlg_globe_tsst.adminUrlSlash + '?cmlg_tnsc=200&cmlg='+currentLang +'&__' + Date.now();
		const response = await fetch(u);

		if (response.ok) {
			let data = await response.text();
			data = data.split('~|~');
			
/* 			if ( data[0] == 'zignore' ){
				//ignore and move to next;
				setTimeout( processOneUrl, 1 );
				return;
			} */
			
			if ( data[0] == 'zz' ){	//all processed.
				isAllProccessed = 1;
				allDone();
				return
			}
			
			if ( data.length >= 5 ){
				//x console.log( 'processOneUrl.data id,lang,link,html:', data[3], data[0], data[1], data[2].substr(0,255) );
				console.log( 'processOneUrl.data:', data[3], data[0], data[1]); //, data[2].substr(0,255) 
				
				//data[0] has lang, data[1] as url, data[2] has html .tpl.html  in defa lang that needs to be translated.
				currentLang = data[0];

				//x urlTransQueue.push( data );
				addToTransQueue( data );
				//console.log( 'processOneUrl.urlTransQueue:', urlTransQueue );
				setTimeout( processOneUrl, 1 );
			}else{
				console.log( 'processOneUrl: invalid data' );
				setTimeout( processOneUrl, 1000 ); //some error so try a bit late
			}
		}else{
			//setTimeout( processOneUrl, 100 ); //some error so try a bit late			
		}
	}
	
	async function allDone(){
		document.body.style.cursor = '';
		
		if (  urlTransQueue.length > 0 ){
			setTimeout( translateOneUrl, 1 ); 
			return;
		}

		await loadLangsNow();
		
		if ( cmlg_globe_tsst.langArray.length > 0 ){
			localStorage.setItem('cmlg_trans_click',1);
			reloadMe( window.location.pathname + '?page=cm-transero' );
			return;
		}

		console.log( 'All Done', urlTransQueue );

		//alert( 'allDone:' );

		//nothing is remaining for translation
		alert('Translation Batch has been completed! \n\nYou can now check your website on the front end. If you find that some pages are still not translated, simply click the "Translate" button again to complete the remaining pages.');
		
		if ( isMnt == 990 ){
			window.close();
		}else{
			try{
				//? window.parent.cmlg__adm_mnt.removeIfm();
			}catch(e){}
		}
		//return;
		
		window.location = window.location.href.replace( '&cmlg_trans_click=1', '' );
		//- window.location.reload();		
	}
	
	function addToTransQueue( data ){
		urlTransQueue.push( data );
/* 		urlTransQueue.sort(function(a, b) {
			if (a < b) {
				return -1; // Sort langCodeA before langCodeB
			}
			if (a > b) {
				return 1; // Sort langCodeB before langCodeA
			}
			return 0; // Maintain original order if the language codes are the same
		});
		console.log( 'tq:', urlTransQueue ); */
	}
	
	function showInfo( pageUrl, h ){
		if ( ! pageUrl.includes( '/for-etc-trans-gene' ) ){
			document.getElementById( 'cmlg_ov_pinfo' ).innerHTML = h;
		}		
	}
	
	function callBackTransDone( transFailedCounter, lang, pageUrl, strTranslated, postId ){
		if ( transFailedCounter > 0 ){
			callTransHelperEv();

			//informFailure( 
			addToTransQueue( [ lang, pageUrl, strTranslated, postId ] );
			console.log( 'callBackTransDone: Translation failed', lang, pageUrl, strTranslated.substr(0, 255) );
			setTimeout( translateOneUrl, 500 ); 
			return;
		}
		//this is the callback function that will be called when gt ifm is done.
		console.log( 'callBackTransDone:', timeEnd( timeStart ), lang, pageUrl ); //, strTranslated.substr(0, 255)
		timeStart = Date.now();
		
		//x const h = '<a href="/' + lang + pageUrl + '" target="_blank">/' + lang + pageUrl + '</a>'; 
		//x const h = '<div>/' + lang + pageUrl + '</div>'; 
		//x document.getElementById('cmlg_ov_pinfo_' + lang ).innerHTML = h;
		//x showInfo( h );

		//send back to the server to save in translated .json file in cmlg_cache folder.
		// it gets saved in mlgpbe already. so not here because keeping it here creates bugs.
		//--- sendTranslatedContent( lang, pageUrl, strTranslated, postId );	
		
		setTimeout( function(){
			//--- processOneUrl();
			translateOneUrl();
		}, 1 );
		
	}
	
	function getOneFromTransQueue(){
		let ux = [];
		// Find the array whose language code matches the provided langCode
		var foundIndex = urlTransQueue.findIndex(function(arr) {
			return arr[0] === currentLangTrans;
		});

		if (foundIndex !== -1) {
			// Remove the array from urlTransQueue using splice
			ux = urlTransQueue.splice(foundIndex, 1)[0];
		
		} else {
			ux 	= urlTransQueue.shift(); //get a url from trans queue.
		}
		
		return ux;
	}
	
	function translateOneUrl(){
		//get a url from the translate queue and set it in iframe for translation.
		//if lang is different from the current url, reload the iframe with url for next lang first.
		
		//console.log('currentLangTrans:', currentLangTrans, 'urlTransQueue:', urlTransQueue.length );
		if ( urlTransQueue.length <= 0 || document.hidden ){
			//console.log( 'translateOneUrl: nothing to do');
			setTimeout( translateOneUrl, 1200 ); 
			return;
		}

		let ux = getOneFromTransQueue();
		
		//console.log( 'translateOneUrl: currentLangTrans:',currentLangTrans,'ux: id,lang,link,html', ux[3], ux[0], ux[1], ux[2].substr(0, 255) );
		console.log( 'translateOneUrl: currentLangTrans:',currentLangTrans,'ux:', ux[3], ux[0], ux[1] );

		if ( !ux[0] || !ux[1] || !ux[2] ){	//|| !ux[3] //post_id 0 is allowed.
			console.log( 'translateOneUrl: some data is empty ', ux);
			setTimeout( translateOneUrl, 1200 ); 
			return;
		}
		
/* 		if ( ux[0] != currentLangTrans  ){
			console.log( 'lang changed to ', ux[0] );
			iframeCreation( ux[0] );
			currentLangTrans = ux[0];
			addToTransQueue( ux );
			
			return;
		} */
		
		//put text in iframe doc by calling a function inside that iframe
		try{
			const h = '<div>/' + ux[0] + ux[1] + '</div>'; 
			showInfo( ux[1], h );
		
			//x obj_mlgpbe[ ux[0] ].kickOffTrans( cmlg_globe_tsst, ux[0], ux[1], ux[2], ux[3] );
			obj_mlgpbe[ 'all' ].kickOffTrans( cmlg_globe_tsst, ux[0], ux[1], ux[2], ux[3], ux[4] );
			
		}catch(e){ 
			console.log( 'translateOneUrl: lang finished', ux[0] );
		}
	}
	
	function iframeCreation( thisLang = '__' ){
		let src	= cmlg_globe_tsst.gtu200;
		
		//- if ( thisLang != currentLangTrans  ){
			//src = src.replace( '%26_x_tr_tl%3D__%26', '%26_x_tr_tl%3D' + thisLang + '%26');
			//src = src.replace( '%26cmlang%3D__%26', '%26cmlang%3D' + thisLang + '%26');
			src = src.replace( '&cmlang=__', '&cmlang=' + thisLang );
			//alert( src );
						
			currentLangTrans = thisLang;
		//- }
		console.log( 'iframeCreation => currentLangTrans:', currentLangTrans, 'gtu src:', src );
		//alert( src );

		eIframe[ thisLang ] = createIframe( src, thisLang );
	}
	
/* 	function sendTranslatedContent( lang, pageUrl, strTranslated, postId ){
		//fire ajax post to send translated text.
		const u = cmlg_globe_tsst.siteUrlSlash + '?__' + Date.now();
		
		var formData = new FormData();
		
		formData.append('cmlg_opcode', '100');
		formData.append('cmlg_lang', lang);
		formData.append('cmlg_page_url', pageUrl);
		formData.append('cmlg_lang_url', '/' + lang + pageUrl);
		formData.append('cmlg_page_html', strTranslated);
		formData.append('cmlg_nonce', cmlg_globe_tsst.nonce);
		formData.append('cmlg_postId', postId);
		
		//
		fetch( u, {
			method: 'POST',
			body: formData,
		})
		.then(response => response.text())
		.then(data => {
			//console.log('Time taken till save is done:', timeEnd( timeStartSave ) );
			console.log('Success:', timeEnd( timeStartSave ), data, cmlg_globe_tsst.siteUrlSlash + lang + pageUrl );
			timeStartSave = Date.now();
		})
		.catch(error => {
			console.error('Error:', error);
		});

	} */
	
	function timeEnd( start ){
		const t = parseInt( ( Date.now() - start )) + '(ms)';
		return t;
	}

	function reloadMe( href = null ){
		if ( ! href ) href = window.location.href;

		window.location = href;
		if ( ! href ) window.location.reload();		
	}
	
	function checkVisibility(){
		if ( isAllProccessed == 1 ) {
			if ( document.hidden ){
				alert( "Do not hide this window/tab behind others. \nPlease ensure that at least a portion of this window remains visible.");
			}
		}
		setTimeout( checkVisibility, 5000 );
	}
	
	function checkFrozen(){
		//return;
		
		const tmp = document.getElementById( 'cmlg_ov_pinfo' );
		
		if ( frozenText == tmp.innerText ){
			localStorage.setItem('cmlg_trans_click',1);
			reloadMe( window.location.pathname + '?page=cm-transero' );
			return;
		}
		
		frozenText = tmp.innerText;
		console.log( 'not frozen', frozenText );
		setTimeout( checkFrozen, 20000 );
	}
	
	function createIframe( src, lang ) {		
/* 		const tmp = document.getElementById('cmlg-ifm-tbe'); 
		if ( tmp ) {
			tmp.src = src;
			return;
			//- tmp.remove();
		} */
		
		showLoadingOverlay( lang );
		
		//console.log( 'ifram url=', src );
		var iframe = document.createElement('iframe');

		iframe.onload = function() {
							setTimeout( function(){
								const iframeWindow = iframe.contentWindow;
								obj_mlgpbe['all'] = new iframeWindow.cmlg__mlgp_be;
								
								ctrFramesLoaded++;
								console.log( "createIframe: ctrFramesLoaded", ctrFramesLoaded );

								//- if ( ctrFramesLoaded >= cmlg_globe_tsst.langArray.length ){
									//document.getElementById( 'cmlg_ov_pinfo' ).innerHTML = 'Starting Translation...';
									
									document.body.style.opacity = 1;

									setTimeout( checkFrozen, 20000 );
									setTimeout( checkVisibility, 5000 );
									
									window.scroll(0,0);
									
									processOneUrl();

									translateOneUrl();
									callTransHelperEv();
									
								//- }
							},1000);
						}

		ctrFrames++;
		iframe.id = "cmlg-ifm-tbe_" + lang;
		iframe.src = src;
		iframe.frameBorder = '0';

		iframe.style.width = '100%'; //'200px';// 
		iframe.style.height = '600px'; //document.body.offsetHeight  + 'px';
		iframe.style.opacity = 0;
		iframe.style.backgroundColor = 'white';
		iframe.style.position = 'absolute';

		iframe.style.left  = "0";
		iframe.style.top  = (ctrFrames - 1) * 100 + 'px'; // '0px';
		//iframe.style.left = (ctrFrames - 1) * 200 + 'px'; // '0px';
		iframe.style.zIndex = 999999999;

		document.body.appendChild(iframe);
		
		return iframe;
	}

	function showLoadingOverlay( lang ) {
		//document.body.style.pointerEvents = 'none';
		$tmp = document.getElementById( 'cmlg_ov_inproc' );
		if ( $tmp ) return;
		
		// Create overlay		
		var overlay = document.createElement('div');
		
		overlay.id = 'cmlg_ov_inproc';
		overlay.style.position = 'fixed';
		overlay.style.top = '0';
		overlay.style.left = '0';
		overlay.style.width = '100%';
		overlay.style.height = '100%';
		
		overlay.style.background = 'rgba(169, 169, 169, 0.7)'; // Light grey color		
		
		//overlay.style.cursor = 'wait';
		overlay.style.display = 'flex';
		overlay.style.flexDirection = 'column'; // Set flex direction to column		
		overlay.style.alignItems = 'center';
		overlay.style.justifyContent = 'center';
		overlay.style.zIndex = '99999999';
	
		// Create spinner
		var spinner = document.createElement('div');
		spinner.style.border = '4px solid rgba(0, 0, 0, 0.3)';
		spinner.style.borderRadius = '50%';
		spinner.style.borderTop = '4px solid #3498db';
		spinner.style.width = '40px';
		spinner.style.height = '40px';
		spinner.style.animation = 'spin 1s linear infinite';
		
		// Define animation
		var animation = document.createElement('style');
		animation.type = 'text/css';
		animation.innerHTML = '@keyframes spin { 0% { transform: rotate(0deg); } 100% { transform: rotate(360deg); } }';
		document.head.appendChild(animation);

		// Apply animation to spinner
		spinner.style.animation = 'spin 1s linear infinite';

		// Append spinner to overlay
		overlay.appendChild(spinner);

		// Create and append a <p> tag below the animation overlay
		var paragraph = document.createElement('h2');
		//x paragraph.id  = 'cmlg_ov_pinfo_' + lang;
		paragraph.id  = 'cmlg_ov_pinfo';
		paragraph.innerHTML = 'Preparing Translation Queue...<br>Do not hide this window behind others. <br>Please ensure that at least a portion of this window remains visible.'; // Set the content of the <p> tag
		
		paragraph.style.textAlign = 'center'; // Center align the text
		paragraph.style.marginTop = '20px'; // Add some top margin
		overlay.appendChild(paragraph);	

		var info = document.createElement('div');
		info.style.textAlign = 'center'; 
		info.innerHTML  = "<h3 style=\"color:white;\">This process is Safe. You can see your website and translated pages now in another window. <br>Just reload this page to stop the process.</h3>";
		overlay.appendChild(info);	


		// Append overlay to body
		document.body.appendChild(overlay);
	}

	async function callTransHelperEv(){
		const u = cmlg_globe_tsst.siteUrlSlash + '?cmlg_oc=600';
		const resp = await fetch( u );
		
		//setTimeout( callTransHelperEv, 2000 );
	}

	async function loadLangsNow(){
		try{
			const u = cmlg_globe_tsst.siteUrlSlash + '?cmlg_oc=700&__' + Date.now();
			console.log('loadLangsNow:',u);

			const response = await fetch(u);
			if (response.ok) {
				const data = JSON.parse( await response.text() );
				cmlg_globe_tsst.langArray = data;
				
				console.log('loadLangsNow:', cmlg_globe_tsst.langArray);
			}

		}catch(e){
			//
		}
	}

	async function kickOff( init ){
		let tOut = 5000;
		try{
			isMnt = window.parent.cmlg__adm_mnt.is_mnt;
			tOut = 1;
		}catch(e){}
		
		console.log( 'kickOff: isMnt:', isMnt );
		
		if ( isMnt == 0 ){
			if ( init == 1 ){
				//on starting installation first time with button click;
				//x get_gene_page();
				startFindUrls();
				document.body.style.cursor = 'wait';
				document.body.style.opacity = 0.6;
			}else{
				//continued translation of next langs.
				tOut = 1;
			}
		}
		
		setTimeout( async function(){
/* 			if ( cmlg_globe_tsst.langArray.length <= 0 ){
				//console.log( cmlg_globe_tsst.langArray ); alert('noo');
				setTimeout( function(){
					reloadMe( window.location.pathname + '?page=cm-transero' ); //&cmlg_trans_click=1
				}, 5000 );
				return;
			} */
			//- if ( cmlg_globe_tsst.langArray.length <= 0 ){
				await loadLangsNow();
				
				if ( cmlg_globe_tsst.langArray.length <= 0 ){
					allDone();
					return;
				}
				currentLang = cmlg_globe_tsst.langArray[0];
				currentLangTrans = currentLang;
			//- }
		
			//- processOneUrl();
			
			//cmlg_globe_tsst.langArray.forEach( lang => {
			//	//alert( lang );
			//	iframeCreation( lang );
			//});
			iframeCreation( currentLang );	//going back to one iframe for all.

		}, tOut);
	}
	
/* 	function get_gene_page_langs(){
		let ctr = 0;
		let tm = 0;
		cmlg_globe_tsst.langsSelected.forEach( lang => {
				ctr++;
				tm = 4000 * ctr;
				setTimeout( function(){
					get_gene_page_lang( lang, tm );
				}, tm);	
			});
	} */
	
	function init(){
		get_gene_page();
		//get_gene_page_langs();
		
		console.log('cmlg__trans_setup inited. currentLang', currentLang);
	}

/* 	tmp = document.querySelector("#cmlg_btn_full_setup0z");
	if ( tmp ){
		tmp.addEventListener("click", function(event) {
			alert( "Click OK to open the translation window.\n\nKeep that tiny window visible and don't let it go behind other windows otherwise the translation process will stop." );
			
			const url = window.location.href + '&cmlg_trans_click=1';
			const width = 50;
			const height = 50;
			const topPosition = 0;
			const leftPosition = 0;

			const popupWindow = window.open(url, '_blank', `width=${width}, height=${height}, top=${topPosition}, left=${leftPosition}`);

		});
	} */
	
	tmp = document.querySelector("#cmlg_btn_full_setup0");
	if ( tmp ){
		tmp.addEventListener("click", function(event) {
			alert( "Click OK to initiate the translation setup. \n\nJust reload this page if you see it frozen. \n\nAvoid hiding this window behind others as it may stop or slow down the setup process. Please ensure that at least a portion of this window remains visible." );
			
			kickOff( 1 );
		});
	}

	tmp = document.querySelector("#cmlg_btn_full_setup1");
	if ( tmp ){
		tmp.addEventListener("click", function(event) {
			kickOff( 0 );
		});
	}
	
	return {
		init:init,
		urlTransQueue:urlTransQueue,
		callBackTransDone:callBackTransDone,
		showInfo:showInfo,
	};
}

o_cmlg__trans_setup = new cmlg__trans_setup();
o_cmlg__trans_setup.init();