(function(){
	console.log( 'mlgp inited' );
	// var runThisScript = ( window.location.host.includes ( '.translate.goog' )
							// || window.location.href.includes ( '?cmlg_oc=200&cmlg_gtu' ) 
							// );
	var runThisScript = window.location.href.includes ( '?cmlg_oc=100&cmlang=' ) 
	
	var waitTime = 500;
	var allRefilled = false;
	var transFailedCounter = 0;
	//var transRetryCounter = 2;
	var transRmgCounter = 0;
	var transRmgCounterMax = 4;

	//
	document.addEventListener("DOMContentLoaded", function(event) {
		//
	});
	
	function checkForDone(){		
		const allParagraphs = __ea('#cmlg_ex_t2 p');
		const rmg = [...allParagraphs].filter(paragraph => !paragraph.querySelector('font'));

		console.log( 'Checking if done', 'rmg:', rmg.length, 'fc:', transRmgCounter );

		if ( rmg.length === 0 || transRmgCounter > transRmgCounterMax ){
			
			if ( rmg.length > 0 && transRmgCounter > transRmgCounterMax ){
				transFailedCounter++;
			}
			
			sendToSave();
			return;
		}else{
			transRmgCounter++;
		}

		gtElInit();
		setTimeout( checkForDone, waitTime);
	}
	
	window.addEventListener("load", function(event) {
		if ( !runThisScript ) return;
		
		console.log( 'window load event!' );
		
		setTimeout( function(){
			checkForDone();
		},waitTime)	
	});

	function removeFontTags(){
		const allPs = document.querySelectorAll('p.cmlg_tpdtl');
		allPs.forEach( p => {
			p.innerHTML = p.innerText;
		});
	}

	function sendToSave(){
		document.getElementById('cmlg_ex_t2').style.display="none";
		removeFontTags();
		let pageHtml = document.getElementById('cmlg_ex_t2').innerHTML.trim();
		
		if ( transFailedCounter > 0 ){
			console.log( 'Translation failed mlgp!', transFailedCounter );
			backToParent();
			return;
		}
		
		var formData = new FormData();
		
		formData.append('cmlg_opcode', '100');
		formData.append('cmlg_lang', cmlg__lang);
		formData.append('cmlg_page_url', cmlg__pageUrl);
		formData.append('cmlg_lang_url', cmlg__langUrl);
		formData.append('cmlg_page_html', pageHtml);
		formData.append('cmlg_nonce', cmlg__nonce);
		
		try{
			formData.append('cmlg_nonce2', cmlg__nonce2);
		}catch(e){}

		try{
			formData.append('cmlg_postId', window.parent.cmlg__postId);
		}catch(e){}

		console.log( 'fetch post fired: ',cmlg__langUrl );
		
		fetch( cmlg__mainUrl + '/', {
			method: 'POST',
			body: formData,
			//headers: {
				//'Content-Type': 'multipart/form-data'
			//},
		})
		.then(response => response.text())
		.then(data => {
			console.log('Success:', data);
			
			//= 
			backToParent();
		})
		.catch(error => {
			console.error('Error:', error);
		});
	}
	
	function backToParent(){
		try{
			window.parent.cmlg__transMenu.transNextLang( transFailedCounter );	//tell parent that translation is done.
			return;
		}catch(e){
			//
		}

		try{
			window.parent.cmlg__adm_mnt.removeIfm();	//tell parent maint_be that translation is done.
			return;
		}catch(e){}
		
		try{
			console.log( 'job done, trying to remove ifm' );
			let parentLocation = '';
			try{
				parentLocation = window.parent.location.href;
			}catch(e){}
			
			console.log( 'parentLocation:', parentLocation );

			if ( ! parentLocation ){	//it is cross domain.
				//--console.log( 'about to change the parent location' );
				//--window.location.href = "https://www.everlive.net/tools0x/cmlg_trans/blank.php";
			}
		}catch(e){}
	}

	//utility funcs
	function removeElements( elements ){
		elements.forEach(function( e ) {
		  e.remove();
		});
	}
	
	function __e( selector ){
		return document.querySelector( selector );
	}

	function __ea( selector ){
		return document.querySelectorAll( selector );
	}
	
	function __rma( selector ){
		var elements = __ea( selector );
		//console.log( elements );
		
		removeElements( elements );
	}
})();